;   map.s
;   code to load static backgrounds in LJ65

;;; Copyright (C) 2009 Damian Yerrick
;
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 3
;   of the License, or (at your option) any later version.
;
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to 
;     Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;     Boston, MA  02111-1307, USA.
;
;   Visit http://www.pineight.com/ for more information.


.segment "CODE"
.global do_intro_screens
.import fbi_warning, palbuf, OAM

DO_PINEIGHT = 1

do_intro_screens:
  lda #<early_pkb
  sta 0
  lda #>early_pkb
  sta 1
  ldy #10
  jsr fbi_warning

.if !DO_PINEIGHT
  lda #<status_pkb
  sta 0
  lda #>status_pkb
  sta 1
  ldy #0
  jsr fbi_warning

  lda #<changes3_pkb
  sta 0
  lda #>changes3_pkb
  sta 1
  ldy #0
  jmp fbi_warning
.else

; load palette for "pin eight" screen
  ldx #31
:
  lda p8_pal,x
  sta palbuf,x
  dex
  bpl :-

; load sprite overlay for "pin eight" screen
  inx
  lda #128-8
  sta 0   ; current x location
  lda #71
  sta 1   ; current y location
  ldy #0
@p8_sprite_sprloop:
  lda p8_map,y
  beq :+
  sta OAM+1,x
  lda 1
  sta OAM,x
  inx
  inx
  lda #0
  sta OAM,x
  inx
  lda 0
  sta OAM,x
  inx
:
  lda 0
  clc
  adc #8
  cmp #128+24
  bcc @not_next_row
  lda 1
  adc #7  ; move down 8 pixels, when carry is set
  sta 1
  lda #128-24
@not_next_row:
  sta 0
  iny
  cpy #32
  bcc @p8_sprite_sprloop

; load nametable for "pin eight" screen
  lda #<pineight_pkb
  sta 0
  lda #>pineight_pkb
  sta 1
  ldy #5
  jmp fbi_warning
.endif

.segment "RODATA"
.global how2_pkb, nesticle_pkb, t_pkb, title_pkb, pause_pkb

p8_pal:
  .byt $30,$10,$00,$0f,$30,$21,$11,$01,$30,$00,$00,$00,$30,$00,$00,$00
  .byt $30,$37,$27,$17,$30,$00,$00,$00,$30,$00,$00,$00,$30,$00,$00,$00
p8_map:
  .byt         216,219,  0,  0
  .byt   0,216,217,218,219,  0
  .byt 216,217,  0,  0,218,219
  .byt 218,219,  0,  0,222,217
  .byt   0,218,219,216,221,  0
  .byt   0,  0,218,217


nesticle_pkb:
  .incbin "obj/nes/nesticle.pkb"

early_pkb:
  .incbin "obj/nes/early.pkb"

.if !DO_PINEIGHT
status_pkb:
  .incbin "obj/nes/status.pkb"

changes3_pkb:
  .incbin "obj/nes/changes3.pkb"
.else
pineight_pkb:
  .incbin "obj/nes/pineight.pkb"
.endif

how2_pkb:
  .incbin "obj/nes/attract.pkb"

t_pkb:
  .incbin "obj/nes/t.pkb"

pause_pkb:
  .incbin "obj/nes/pause.pkb"

title_pkb:
  .incbin "obj/nes/title.pkb"

